#include "http.h"

#include <string_view>

#include <cassert>

namespace saw {
HttpNetwork::HttpNetwork(Network& network):
	internal{&network}{}


Own<HttpServer> HttpNetwork::listen(NetworkAddress& address){
	assert(internal);

	auto eov = internal->listen(address);
	/// @todo unimplemented

	return nullptr;
}

namespace {
struct HttpClientStreamHelper {
	Own<ConveyorFeeder<Own<HttpStream>> 

	Own<IoStream> stream = nullptr;
};
}

Conveyor<Own<HttpStream>> HttpNetwork::connect(NetworkAddress& address){
	assert(internal);

	Own<HttpClientStreamHelper> helper = heap<HttpClientStreamHelper>();

	// Create a type of break point
	helper->sink = internal->connect(address).then([help_ptr = helper.get()](Own<IoStream> stream) -> ErrorOr<void> {
		assert(stream);

		help_ptr->stream = std::move(stream);

		return;
	}).sink();

	auto caf = newConveyorAndFeeder<Own<HttpStream>>();
	helper->feeder = std::move(caf.feeder);

	return caf.conveyor.attach(std::move(helper));
}
}
